10 REM N1II OCTOBER 11, 1995 V 1.0
20 REM THIS SOFTWARE MAKES A D/A CONVERSION AND
30 REM READS IT THROUGH THE PARALLEL
40 REM PRINTER PORT ON A PC
50 REM ***********************
60 REM INITIAL SETUP
70 SCREEN 0                     	'PICK 80 COLUMN TEXT MODE
80 COLOR 2, 0                   	'I LIKE GREEN ON BLACK
90 CLS                         		'FIRST CLEAR THE SCREEN
100 CLEAR                       		'THEN CLEAR ALL VARIABLES
105 PORTO = &H378              	'DEFINE OUTPUT PORT
110 DEFINT C-O                  	'ALL VARIB. STARTING W/ C-O ARE INTEGERS
200 '*************************   THIS IS THE START OF THE PROGRAM
230 INPUT " INPUT  ",AIN         	'RAW CHANNEL A INPUT
250 CIN=(AIN/5)*255                    'SCALE TO 255 MAX
500 '**************************  NOW GET 8 BIT WORD OF CIN
510 IF CIN>127 THEN D7=1:CIN=CIN-128    	'BIT 7
520 IF CIN>63  THEN D6=1:CIN=CIN-64     	'BIT 6
530 IF CIN>31  THEN D5=1:CIN=CIN-32     	'BIT 5
540 IF CIN>15  THEN D4=1:CIN=CIN-16     	'BIT 4
550 IF CIN>7   THEN D3=1:CIN=CIN-8      	'BIT 3
560 IF CIN>3   THEN D2=1:CIN=CIN-4      	'BIT 2
570 IF CIN>1   THEN D1=1:CIN=CIN-2      	'BIT 1
580 IF CIN=1   THEN D0=1                		'BIT 0
1000 '******************        	SET UP FOR  CONVERSION
1010 OUT PORTO,2                	'CS(NOT) HIGH, CONTROL BIT LOW
1020 OUT (PORTO=2),2            	'CLOCK LINE LOW
1030 OUT PORTO,0                	'CS(NOT) LOW, CONTROL LOW  (=0)
1040 FOR N=1 TO 7               	'SET UP FOR 7
1050 GOSUB 5000                 	'CLOCK PULSES
1060 NEXT N
1070 OUT PORTO,1                	'CS(NOT) LOW, CONTROL HIGH (=1)
1080 GOSUB 5000                 	'GET ANOTHER CLOCK
2000 '******************        		 NOW FOR  DATA BITS
2010 OUT PORTO,D7               	'OUTPUT D7 (DATA, MSB FIRST)
2020 GOSUB 5000                 	'CALL A CLOCK
2030 OUT PORTO,D6               	'OUTPUT D6
2040 GOSUB 5000                 	'CALL A CLOCK
2050 OUT PORTO,D5
2060 GOSUB 5000
2070 OUT PORTO,D4
2080 GOSUB 5000
2090 OUT PORTO,D3
2100 GOSUB 5000
2110 OUT PORTO,D2
2120 GOSUB 5000
2130 OUT PORTO,D1
2140 GOSUB 5000
2150 OUT PORTO,D0               	'LAST DATA BIT (LSB)
2160 GOSUB 5000
2170 OUT PORTO,2                	'CS(NOT)HIGH, DATA/CONTROL LOW
2180 '                          		     EXCUTES CONVERSION
4990 END
5000 '*****************	CLOCK PULSE ROUTINE
5010 CD=1				'SET CLOCK WIDTH
5020 OUT (PORTO+2),0                    'SET PIN 14 (AUTOLF(NOT)) HIGH
5030					'THIS SETS CLOCK HIGH
5040 FOR CW = 0 TO CD STEP 1:NEXT CW		'SET CLOCK WIDTH
5050 OUT (PORTO+2),2                    'SET PIN 14 LOW (END OF CLOCK)
5060 RETURN
